﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraMovement : MonoBehaviour
{

    private static float spare;
    private static bool isSpareReady = false;

    // Start is called before the first frame update
    void Start()
    {
        Random.seed = (int)System.DateTime.Now.Ticks;
    }

    // Update is called once per frame
    void Update()
    {
        Vector3 npos = transform.position;
        npos.x = 900 - Random.Range(0, 1800);
        npos.z = 900 - Random.Range(0, 1800);
        npos.y = Terrain.activeTerrain.SampleHeight(npos) + Random.Range(15, 120);
        transform.position = npos;

        float ry = Random.Range(0f, 360f);
        float rx = 90 + (9 * getGaussian(0, 2)); //Random.Range(-15f, 15f);
        float rz = (9 * getGaussian(0, 2));
        transform.rotation = Quaternion.Euler(rx, ry, rz);
    }

    // Marsaglia polar method implementation, derived from java implementation at https://en.wikipedia.org/wiki/Marsaglia_polar_method
    float getGaussian(float mean, float stdDev)
    {
        if (isSpareReady)
        {
            isSpareReady = false;
            return spare * stdDev + mean;
        }
        float u, v, s;
        do
        {
            u = Random.value * 2 - 1;
            v = Random.value * 2 - 1;
            s = u * u + v * v;
        } while (s >= 1 || s == 0);
        float mul = Mathf.Sqrt(-2.0f * Mathf.Log(s) / s);
        spare = v * mul;
        isSpareReady = true;
        return mean + stdDev * u * mul;
    }

}
